


#ifndef PATMIF_H
#define PATMIF_H
 
#define MAX_LOCAL_IP_NUMBER     128
#define MAX_ATM_ADAPTERS        4
#define MAX_NAME_LENGTH         1024

#define PROTOCOL_DRIVER_NTX_DRIVERNAME  "PATMDRV.SYS"
#define PROTOCOL_DRIVER_NAME            "PATMDRV"
#define PROTOCOL_DRIVER_PREFIX          TEXT("PATtmDrv")
#define PROTOCOL_DRIVER_DESC            TEXT("Protocol Driver for ndis5 PROATM Driver")

#define     MAX_LINK_NAME_LENGTH		128
#define     MAX_MAC_NAME_LENGTH			32

#define		ETH_802_3_HEADER_LENGTH		14
#define		ETH_802_3_ADDRESS_LENGTH	6


#define DFLT256_SRAM_SIZE		0x04000
#define DFLT1K_SRAM_SIZE		0x08000
#define DFLT4K_SRAM_SIZE		0x20000
#define DFLT16K_SRAM_SIZE		0x80000

typedef struct _ETH_802_3_FRAME
{
	BYTE	DestinationAddress[ ETH_802_3_ADDRESS_LENGTH ];
	BYTE	SourceAddress[ ETH_802_3_ADDRESS_LENGTH ];
	BYTE	LengthCount[2];
	BYTE	PduBuffer[1];
}
ETH_802_3_FRAME, *PETH_802_3_FRAME;

typedef struct {UCHAR Digit[6];}  MACADDRESS;

enum ADAPTER_TYPE
{
	NDIS_ADAPTER,
	WDM_ADAPTER
};

/* definitions of network interface structure (one per physical interface)	*/
typedef struct _ATM_ADAPTER                     /* info about one net interface	*/
{				     
	HANDLE		hFile;         
	ADAPTER_TYPE AdapterType;
	BOOL        bCreatedDevice;	            /* interface states: NIS_above	*/
	char		IdentString[MAX_NAME_LENGTH+1];
	char		DriverDesc [MAX_NAME_LENGTH+1];
	char        PnpInstanceID[MAX_NAME_LENGTH+1];
	ULONG       Speed;
    ULONG       MemorySize;
    ULONG       LinkStatus;
    MACADDRESS	MacAddress;
	DWORD		IpAddress;
	DWORD		IpMask;
    DWORD       DriverVersion;
} ATM_ADAPTER, *PATM_ADAPTER, **PPATM_ADAPTER;





typedef struct _PROTOCOL_DRIVER 
{
  HANDLE       hEvent;
  OVERLAPPED   OverLapped;
  PVOID        Buffer;
  UINT         Length;
  ULONG		   ulBytesReceived;
  BOOL		   bIoComplete;
} 
PROTOCOL_DRIVER, *LPPROTOCOL_DRIVER;

struct Stack
{
	char NetIdent[MAX_NAME_LENGTH+1];
	char DeviceDesc[MAX_NAME_LENGTH+1];
	char PnpInstanceID[MAX_NAME_LENGTH+1];
	BOOL   IsEthernetDevice;
	DWORD  IpAddress;
	DWORD  IpMask;
	int    GatewayCount;
	DWORD  GatewayAddress[16];
	DWORD  MaxMTU;

};

typedef struct _ATM_APPLICATION_INFO
{
    ULONG MemorySize;
    ULONG Speed;
    char  MacAddress[6];
    ULONG LinkStatus;
    ULONG DriverVersion;

} ATM_APPLICATION_INFO, *PATM_APPLICATION_INFO;

#define OID_ATM_APPLICATION_INFO  0x080102F0
#define OID_ATM_SET_LOOPBACK_MODE 0x080102F1


BOOL              ProtocolATMStart          ();
BOOL              ProtocolATMStop           ();
BOOL              ProtocolATMGetInformation ( PATM_ADAPTER pAdapter);
BOOL	          ProtocolATMSetLoopback    ( PATM_ADAPTER lpAdapter, BOOL bLoopback);
BOOL			  FindNetworkATMAdapters    ( PATM_ADAPTER Adapter, DWORD *AdapterCount);
LPPROTOCOL_DRIVER ProtocolATMAllocateData( void );
BOOL              ProtocolATMInitData( LPPROTOCOL_DRIVER	lpProtocolATM,  UINT Length );
VOID			  ProtocolATMFreeData( LPPROTOCOL_DRIVER lpProtocolATM );
BOOL			  ProtocolATMDeviceIoControl( PATM_ADAPTER pAdapter, LPPROTOCOL_DRIVER lpProtocolATM, ULONG ulIoctl, BOOL bSync);




#endif /* PATMIF_H */
